Attribute VB_Name = "modGeneral"
Option Explicit
Public Type BrowseInfo
    hWndOwner               As Long
    pIDLRoor                As Long
    pszDisplayName          As Long
    lpszTitle               As Long 'it is a pointer to the title
    ulFlags                 As Long
    lpfnCallback            As Long
    lParam                  As Long
    iImage                  As Long
End Type

Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpbi As BrowseInfo) As Long

Public Function ExtractFile(ByVal Pathname As String) As String
    Dim f$, n%
    ' Returns the filename portion of a full pathname

    f$ = Pathname

    Do
        n% = InStr(f$, "\")
        If n% > 0 Then f$ = Right$(f$, Len(f$) - n%)
    Loop While n% > 0
    Do
        n% = InStr(f$, "/")
        If n% > 0 Then f$ = Right$(f$, Len(f$) - n%)
    Loop While n% > 0

    ExtractFile = f$

End Function

Public Function ExtractExtension(ByVal Pathname As String) As String
    Dim File$, k%
    Dim s$
    File$ = ExtractFile(Pathname)
    s$ = ""
    k = 0
    Do
       k = InStr(k + 1, File$, ".")
       If k <> 0 Then
          s$ = Mid$(File$, k + 1)
       Else
          Exit Do
       End If
    Loop
    ExtractExtension = s$
End Function
Public Function ExtractPath(Pathname As String) As String
    Dim f$, n%
    ' Return the directory path portion of a full pathname

    f$ = Pathname

    Do
        n% = InStr(f$, "\")
        If n% > 0 Then f$ = Right$(f$, Len(f$) - n%)
    Loop While n% > 0
    Do
        n% = InStr(f$, "/")
        If n% > 0 Then f$ = Right$(f$, Len(f$) - n%)
    Loop While n% > 0

    ExtractPath = Left$(Pathname, Len(Pathname) - Len(f$))
End Function

Public Function ExtractBase(ByVal Pathname As String) As String
    Dim f$, n%
    ' Return the basename portion of a full pathname
    f$ = ExtractFile(Pathname)
    n% = InStr(f$, ".")
    If n% > 0 Then f$ = Left$(f$, n% - 1)
    ExtractBase = f$
End Function

Public Function WithSlash(a$) As String
    'adds a backslash to the end of a string when it is missing
    If Len(a$) > 0 Then
        If Right$(a$, 1) <> "\" Then
           WithSlash = a$ + "\"
        Else
           WithSlash = a$
        End If
    End If
End Function

Public Function strChooseFolder(hWndOwner As Long, strPrompt As String) As String
    'this is a very useful API trick to allow the user for selecting a directory without
    'using any VB control
    Dim intNull As Integer
    Dim lngIDList As Long
    Dim lngResult As Long
    Dim strPath As String * 280
    Const BIF_RETURNONLYFSDIRS = 1
    Dim udtBI As BrowseInfo
        udtBI.hWndOwner = hWndOwner
        udtBI.lpszTitle = lstrcat(strPrompt, "")
        udtBI.ulFlags = BIF_RETURNONLYFSDIRS

    lngIDList = SHBrowseForFolder(udtBI)
    If lngIDList Then
        lngResult = SHGetPathFromIDList(lngIDList, strPath)
        Call CoTaskMemFree(lngIDList)
    End If
    
    strChooseFolder = CutZero(strPath)
End Function

Public Function CutZero(ByVal s As String) As String
    Dim i As Long
    'removes the zero characters from the end of a string
    i = InStr(Trim$(s), Chr$(0))
    If i = 0 Then
        CutZero = Trim$(s)
    Else
        CutZero = Trim$(Left$(Trim$(s), i - 1))
    End If
End Function

